/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FilterRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FilterRequest{}

// FilterRequest struct for FilterRequest
type FilterRequest struct {
	Source *string `json:"source,omitempty"`
	//
	Rules []FilterRuleRequest `json:"rules,omitempty"`
}

// NewFilterRequest instantiates a new FilterRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFilterRequest() *FilterRequest {
	this := FilterRequest{}
	return &this
}

// NewFilterRequestWithDefaults instantiates a new FilterRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFilterRequestWithDefaults() *FilterRequest {
	this := FilterRequest{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *FilterRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FilterRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *FilterRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *FilterRequest) SetSource(v string) {
	o.Source = &v
}

// GetRules returns the Rules field value if set, zero value otherwise.
func (o *FilterRequest) GetRules() []FilterRuleRequest {
	if o == nil || IsNil(o.Rules) {
		var ret []FilterRuleRequest
		return ret
	}
	return o.Rules
}

// GetRulesOk returns a tuple with the Rules field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FilterRequest) GetRulesOk() ([]FilterRuleRequest, bool) {
	if o == nil || IsNil(o.Rules) {
		return nil, false
	}
	return o.Rules, true
}

// HasRules returns a boolean if a field has been set.
func (o *FilterRequest) HasRules() bool {
	if o != nil && !IsNil(o.Rules) {
		return true
	}

	return false
}

// SetRules gets a reference to the given []FilterRuleRequest and assigns it to the Rules field.
func (o *FilterRequest) SetRules(v []FilterRuleRequest) {
	o.Rules = v
}

func (o FilterRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FilterRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Rules) {
		toSerialize["rules"] = o.Rules
	}
	return toSerialize, nil
}

type NullableFilterRequest struct {
	value *FilterRequest
	isSet bool
}

func (v NullableFilterRequest) Get() *FilterRequest {
	return v.value
}

func (v *NullableFilterRequest) Set(val *FilterRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFilterRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFilterRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFilterRequest(val *FilterRequest) *NullableFilterRequest {
	return &NullableFilterRequest{value: val, isSet: true}
}

func (v NullableFilterRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFilterRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
